#------------------------ 'plain text' Module ------------------------

%html2plain = ('&gt;' => '>',
               '&lt;' => '<',
               '&quot;' => "\"",
               '&amp;' => '&',
               );
$html2plain = join('|', (sort {length $b <=> length $a} keys %html2plain));

sub html2plain{
    my $str = shift;
    my($tmp);

    while ($str =~ s/^(.*?)(\<|\e\$[\@B]|[\x80-\xff])/$2/s){
        $tmp .= $1;
        next if $str =~ s/\<\!\-\- .*? \-\-\>//s;
        $tmp .= "\n", next if $str =~ s/^<br( \/)?\>\n?//i;
        next if $str =~ s/^\<.*?\>//;
        $tmp .= $1, next if $str =~ s/^([\x80-\xff].?|\e\$[\@B].*?\e\([BJ])//;
        $tmp .= $1 if $str =~ s/^.//;
    }
    $str = $tmp . $str;

    $str =~ s/($html2plain)/$html2plain{$1}/g;
    $str;
}

sub decode_url{
    my $str = shift;
    $str =~ s/\+/ /g;
    $str =~ s/%(..)/chr(hex($1))/ge;
    $str;
}
1;
#-------------------- End of 'plain text' Module ---------------------
