# regconv.pl - 1998.09.09 by furukawa@tcp-ip.or.jp -*- perl -*-

sub main::regconv{
    # ɽ EUC б (ʤ) Ѵ
    # 㤨
    #     [-] -> (?:\xff\xA4[\xA2-\xA6]|\xff)
    #     [^] -> ([\xA1-\xAF\xB1-\xFE][\xa1-\xfe]|\xB0[\xA2-\xFE]|[\x00-\x7F])
    # Ȥä硣
    #
    # usage: $pattern = &regconv($original_pattern [, $option]);
    #
    # ֤ͤϡѴΥѥ
    #
    #  '$'  quote Τǡѥѿ̾뤳Ȥ
    # ǤʤɬפʤѴ˽Ƥȡ
    #
    # '@', '%', '/'  quote 롣
    # 
    # \ Υѥϡɬ 8 ʿȤư롣
    # 
    # \x(16ʿ) Υѥǡͤ 0x80 ʾΤȤϡ
    # ̥ХȤȤʸѴ롣
    #
    # $original_pattern ϡSCALAR ޤϡSCALAR ؤΥե
    #   ե󥹤Ǥäˤϡѥ礬äȤ
    #   ˡΤ᤹
    #
    # $option ϡHASH ؤΥե󥹤ȤͿ
    #   HASH ΥȤơΤΤȤ
    #       'pl'    2 Хʸ̤κ¦ˡ'(' Ǥʤ '(?:' 
    #               ȤȤʤȡѥΥåΰ֤
    #               ѤΤǡ$1, $2, ... ϻȤʤʤ
    #       'case'  ʸ饹Ÿݡʸʸ̤
    #       'ff'    2 Хʸ \xff 롣ˤꡢ
    #               ʸǧʤ褦ˤǤ뤬оݤ
    #               ʸϡäơ
    #                   s/([\xa1-\xfe].)/\xff$1/g;
    #               ȤäѴ򤷤Ƥɬפ롣
    #       'ex'    γĥͭˤ
    #                   \H        Ҥ餬 (\xa4[\xa1-\xf3])
    #                   \K         (\xa5[\xa1-\xf6]|\xa1\xbc)
    #                   \J             ([\xb0-\xf4][\xa1-\xfe])
    #                   \X0000    2 Хʸ
    #
    #   ޤѥ 2 Хʸޤ硢'MB' Ȥ 1 
    #   ᤵ롣

    my $ptr = shift;
    my $str = (ref($ptr) eq 'SCALAR')? $$ptr: $ptr;
    my $opt = @_? shift: '';

    my $ex = 0;
    my $ff = '';
    my $case = 0;
    my ($pl, $pr) = ("(", ")");

    if (ref($opt) eq 'HASH'){
        my $key;
        $ex = $opt->{'ex'} if defined $opt->{'ex'};
        $ff = "\\xff" if defined $opt->{'ff'};
        $case = $opt->{'case'} if defined $opt->{'case'};
        $pl = "(?:" if defined $opt->{'pl'};
    }

    my $kclass = "\\xa1-\\xff";
    my $knj = "$ff\[\\xa1-\\xfe\]\[\\xa1-\\xfe\]";

    my $eol = ($str =~ s/\$$//);
    my $plevel = 0;
    my %work = ('UL' => '', 'Q' => '', 'Ex' => $ex, 'MB' => 0);
    my $fix = '';
    my $pat = '';

    while ($str !~ /^$/){
        my $ch = &regconv::reggetc(\%work, \$str);
        ++$plevel if $ch eq '(';
        if ($ch eq ')'){
            next unless $plevel;
            --$plevel;
        }

        # '$', '@', '%', '/'  quote
        $ch = "\\$ch" if $ch =~ /^[\/\$\@\%]$/;

        $fix .= $ch;
        $pat .= "$pl$ff$ch$pr", next if $ch =~ /^[\xa1-\xfe]{2}$/;
        $pat .= "$pl\[^\\n$kclass]|$knj$pr", next if $ch eq '.';
        $pat .= "$pl\[^\\w$kclass]|$knj$pr", next if $ch eq "\\W";
        $pat .= "$pl\[^\\s$kclass]|$knj$pr", next if $ch eq "\\S";
        $pat .= "$pl\[^\\d$kclass]|$knj$pr", next if $ch eq "\\D";

        $pat .= "$pl$ff$ch\[\\xa1-\\xfe\]$pr", next if $ch =~ /^\\x[a-fA-F]./;

        if ($ex){
            $pat .= "$pl$ff\\xa4[\\xa1-\\xf3]$pr", next if $ch eq "\\H";
            $pat .= "$pl$ff\\xa5[\\xa1-\\xf6]|$ff\xa1\xbc$pr", next if $ch eq "\\K";
            $pat .= "$pl$ff\[\\xb0-\\xf4\]\[\\xa1-\\xfe\]$pr", next if $ch eq "\\J";
            if ($ch =~ s/^\\X//){
                my $code = hex $ch;
                if ($code < 0x80){
                    $pat .= sprintf("\\x%02X", $code);
                }elsif ($code < 0x100){
                    $pat .= sprintf("$pl$ff\\x%02X[\\xa1-\\xfe]$pr", $code);
                }else{
                    $code |= 0x8080;
                    my $hi = $code >> 8;
                    my $lo = $code & 0xff;
                    my $tmp = &regconv::hex4($hi, $lo);
                    $pat .= "$ff$tmp" if $tmp ne '';
                }
                next;
            }
        }
        $pat .= $ch, next if $ch ne "\[";

        my $sign;
        $fix .= $1 if $sign = ($str =~ s/^(\^)//);
        if ($str ne ''){
            my %vct = ();
            $vct{'sign'} = $sign;
            $vct{'case'} = $case;
            $vct{0} = $vct{0xa1} = $vct{'all'} = $vct{'set'} = '';
            for (my $i = 0; $i < 128; $i++){vec($vct{0}, $i, 1) = $sign};
            for (my $i = 0xa1; $i <= 0xfe; $i++){
                vec($vct{0xa1}, $i, 1) = $sign;
                vec($vct{'all'}, $i, 1) = !$sign;
                vec($vct{'set'}, $i, 1) = 1;
            }
            for (my $i = 0xa2; $i <= 0xfe; $i++){ $vct{$i} = $vct{0xa1}};

            my $flag = 0;
            for(;;){
                my $x = &regconv::reggetc(\%work, \$str);
                my $y;
                $x = "\]" if $x eq '';
                $fix .= $x;
                last if $x eq ']' && $flag; # λ
                $flag = 1;
                if ($x =~ /\\[wWsSdDHKJ]/
                    || $work{'Q'} || $str !~ /^\-[^\]]/){

                    if ($x =~ /([\xa1-\xfe])([\xa1-\xfe])/){
                        &regconv::mvect(\%vct, ord $1, ord $2);
                    }elsif ($ex && $x =~ /\\H/){
                        for $y (0xa1..0xf3){
                            &regconv::mvect(\%vct, 0xa4, $y);
                        }
                    }elsif ($ex && $x =~ /\\K/){
                        for $y (0xa1..0xf6){
                            &regconv::mvect(\%vct, 0xa5, $y);
                        }
                        &regconv::mvect(\%vct, 0xa1, 0xbc);
                    }elsif ($ex && $x =~ /\\J/){
                        for $y (0xb0..0xf4){
                            $vct{$y} = $vct{'all'};
                        }
                    }else{
                        &regconv::svect(\%vct, $x);
                        if ($x =~ /^(\.|\\[WSD])$/){
                            for $y (0xa1..0xfe){
                                $vct{$y} = $vct{'all'};
                            }
                        }
                    }
                    next;
                }

                &regconv::reggetc(\%work, \$str); $fix .= '-';
                $y = &regconv::reggetc(\%work, \$str);
                $fix .= $y;

                if ($x =~ /^([\xa1-\xfe])([\xa1-\xfe])$/){
                    my ($x0, $x1) = (ord $1, ord $2);
                    if ($y =~ /^([\xa1-\xfe])([\xa1-\xfe])$/){
                        my ($y0, $y1) = (ord $1, ord $2);
                        if ($x0 < $y0 && $x0 > 0xa1){
                            &regconv::mvect(\%vct, $x0, $x1++) while $x1 < 0xff;
                            ++$x0; $x1 = 0xa1;
                        }
                        $vct{$x0} = $vct{'all'}, ++$x0 while $x0 < $y0;
                        if ($x0 == $y0){
                            &regconv::mvect(\%vct, $x0, $x1++) while $x1 <= $y1;
                        }
                    }
                }else{
                    &regconv::svect(\%vct, "$x-$y");
                }
            }

            my $mark = $pl;
            $flag = 0;
            for (my $x = 0xa1; $x <= 0xfe; $x++){
                next unless $vct{$x} eq $vct{'set'};
                my $y;
                for ($y = $x + 1; $y <= 0xfe; $y++){
                    last unless $vct{$y} eq $vct{'set'};
                }
                $flag = 1, $pat .= $mark . '\xff[' unless $flag;
                $pat .= &regconv::rangestr($x, $y - 1);
                $x = $y;
            }
            $pat .= '][\xa1-\xfe]', $mark = '|' if $flag;

            my $x;
            for ($x = 0xa1; $x <= 0xfe; $x++){
                next if $vct{$x} eq $vct{'set'};
                if ($vct{$x} !~ /^\x00*$/){
                    $flag = '';
                    for (my $l = 0xa1; $l <= 0xfe; $l++){
                        next unless vec($vct{$x}, $l, 1);
                        my $r;
                        for ($r = $l + 1; $r <= 0xfe; $r++){
                            last unless vec($vct{$x}, $r, 1);
                        }
                        unless ($flag){
                            $pat .= "$mark$ff";
                            $pat .= chr($x) . chr($l), last if $l == $r - 1 && $vct{$x} =~ /^\x00*/;
                            $flag = ']';
                            $pat .= sprintf("\\x%02X[", $x);
                        }
                        $pat .= &regconv::rangestr($l, $r);
                        $l = $r;
                    }
                    $pat .= $flag;
                    $mark = '|';
                }
            }

            $mark = '' if $mark eq $pl;
            if ($vct{0} !~ /^\x00*$/){
                $pat .= $mark . '[';
                for (my $l = 0; $l < 128; $l++){
                    next unless vec($vct{0}, $l, 1);
                    my $r;
                    for ($r = $l + 1; $r < 128; $r++){
                        last unless vec($vct{0}, $r, 1);
                    }
                    $pat .= &regconv::rangestr($l, $r - 1);
                    $l = $r;
                }
                $pat .= ']';
            }
            $pat .= $pr if $mark;
        }
    }
    $fix .= ')', $pat .= ')' while $plevel--;
    $fix .= "\$", $pat .= "\$" if $eol;

    $opt->{'MB'} = $work{'MB'} if ref($opt) eq 'HASH';
    $$ptr = $fix if ref($ptr) eq 'SCALAR';

    return $pat;
}

sub regconv::vrange{
    my ($pv, $ps) = @_;
    for (; $$ps < 128; ++$$ps){
        next unless vec($$pv, $$ps, 1);
        vec($$pv, $$ps, 1) = 0;
        my $tmp;
        for ($tmp = 1 + $$ps; $tmp < 128; $tmp++){
            vec($$pv, $tmp, 1) = 0 while vec($$pv, $tmp, 1);
        }
    }
    
}

sub regconv::rangechar{
    my $ch = shift;
    if (chr($ch) =~ /^\w$/){
        return chr $ch;
    }else{
        return sprintf("\\x%02X", $ch);
    }
}

sub regconv::rangestr{
    my($x, $y) = @_;
    ($x == $y)?
        &regconv::rangechar($x):
            &regconv::rangechar($x) . "-" . &regconv::rangechar($y);
}



sub regconv::svect{
    # 󥰥ХʸѤΥ٥
    my($ptr, $pat) = @_;
    my $v = !$ptr->{'sign'};
    my $i;
    if ($ptr->{'case'}){
        for $i (0..0x7f){
            vec($ptr->{0}, $i, 1) = $v if eval{chr($i) =~ /[$pat]/};
        }
    }else{
        for $i (0..0x7f){
            vec($ptr->{0}, $i, 1) = $v if eval{chr($i) =~ /[$pat]/i};
        }
    }
}

sub regconv::mvect{
    # ޥХʸѤΥ٥
    my($ptr, $x, $y) = @_;
    my $v = !$ptr->{'sign'};
    vec($ptr->{$x}, $y, 1) = $v;
}

sub regconv::reggetc{
    my ($tmp, $ptr) = @_;
    while ($$ptr !~ /^$/){
        if ($$ptr =~ s/^\\([ULQE])//){
            # \U, \L, \Q, \E
            if ($1 eq 'E'){
                chop $tmp->{'mode'};
            }else{
                # \U, \L, \Q ΥͥȽ
                $tmp->{'mode'} .= $1;
            }
            $tmp->{'Q'} = ($tmp->{'mode'} =~ tr/Q/Q/);

            # Ǹ \U, \L
            $tmp->{'UL'} = (($tmp->{'mode'} =~ /([UL])[^UL]*$/)? $1: '');
            next;
        }

        if ($$ptr =~ s/^\\([ul])//){
            # \u, \l (ʸѴ) 
            if (&regconv::ul($ptr, $1)){
                $$ptr =~ s/^(.)//;
                return $1;
            }
        }
        &regconv::ul($ptr, $tmp->{'UL'});
        
        # 1 ʸɤ߽Ф
        $tmp->{'MB'} = 1, return $1 if $$ptr =~ s/^([\xa1-\xfe]{2})//;
        return $1 if $$ptr =~ s/^(\w)//;
        return '' unless $$ptr =~ s/^(.)//;

        my $ch = $1;
        if ($tmp->{'Q'}){
            my $cnt = $tmp->{'Q'};
            $ch = quotemeta($ch) while $cnt--;
            return $ch;
        }
        return $ch if $ch ne "\\";

        # \ ν

        &regconv::ul($ptr, $tmp->{'UL'});

        # \c. (ȥʸν)
        return "\\c" . ($$ptr =~ s/^(.)//? $1: '@') if $$ptr =~ s/^c//;
    
        # \000 (8 ʿν)
        return "\\x00" if $$ptr =~ /^[89]/;
        $tmp->{'MB'} = 1, return sprintf("\\x%02X", oct($1)) if s/^([4-7][0-7]{2})//;
        return sprintf("\\x%02X", oct($1)) if s/^([0-7]{1,3})//;

        # \x00 (16 ʿ) ν
        $tmp->{'MB'} = 1, return $ch . $1 if $$ptr =~ s/^(x[89a-fA-F][\da-fA-F])//;
        return $ch . $1 if $$ptr =~ s/^(x[\da-fA-F]{1,2})//;

        if ($tmp->{'Ex'}){
            $tmp->{'MB'} = 1, return $ch . $1 if $$ptr =~ s/^(X[\da-fA-F]{3,4})// || $$ptr =~ s/^(X[89a-fA-F][\da-fA-F])//;
            return $ch . $1 if $$ptr =~ s/^(X[\da-fA-F]{0,4})//;
            $tmp->{'MB'} = 1 if $$ptr =~ /^[HKJ]/;
        }
        # ¾
        return $ch . $1 if $$ptr =~ s/^([\x20-\x7e])//;
        return "\\\\";
    }
    return '';
}


sub regconv::ul{
    # Ƭ 1 ʸ /ʸ Ѵ
    my ($ptr, $ul) = @_;
    return $$ptr =~ s/^([A-Za-z])/\u$1/ if $ul =~ /^u/i;
    return $$ptr =~ s/^([A-Za-z])/\l$1/ if $ul =~ /^l/i;
}

sub regconv::hex4{
    my ($hi, $lo) = @_;
    return '' if $hi < 0xa1 || 0xfe < $hi || $lo < 0xa1 || 0xfe < $lo;

    if (0xa4 == $hi && $lo <= 0xf3
        or $hi == 0xa5 && $lo <= 0xf6
        or $hi == 0xa1 && $lo == 0xbc
        or $hi == 0xa6 && ($lo <= 0xb8 or 0xc1 <= $lo && $lo <= 0xd8)
        or $hi == 0xa7 && ($lo <= 0xc1 or 0xd1 <= $lo && $lo <= 0xf1)
        or 0xb0 <= $hi && $hi <= 0xce
        or $hi == 0xcf && $lo <= 0xd3
        or 0xd0 <= $hi && $hi <= 0xf3
        or $hi == 0xf4 && $lo <= 0xa4
        ){
        return chr($hi) . chr($lo);
    }
    return sprintf("\\x%02X\\x%02X", $hi, $lo);
}
1;
