#! /usr/local/bin/perl5 -w
# -*- Perl -*-
#
# nmz-filter.pl
#       by furukawa@tcp-ip.or.jp
#
# Usage: perl nmz-filter.pl PATTERN INDEX_DIR
#
# ޥɥ饤ˤɾ򵭽Ҥ뤳Ȥˤꡢʤñ
# ǥå뤳ȤǤޤˤꡢǥ
# Υ򸺤餹ȤǤޤ
#
# PATTERN ɾˤϡ$_ оݤȤʤñ줬äƤޤ
# ĤȤ˿֤褦 PATTERN ꤷƤ
#

use strict;

push(@INC, '/usr/local/share/namazu/pl');
{
    my($tmp) = $0;
    $tmp = "./$tmp" if $tmp !~ /[\/\\]/;
    while ($tmp =~ /^(.*[\/\\])/){
        unshift(@INC, $1);
        last if !-l $tmp;
        $tmp = $1 . $tmp if ($tmp = readlink($tmp)) !~ /^\//;
    }
}
require 'nmzidx.pl';

my $opt_windows_drive = 0;
my $opt_testonly = 0;
my $opt_verbose = 0;

while (@ARGV && $ARGV[0] =~ s/^\-//){
    my $argv = shift(@ARGV);
    if ($argv =~ s/^\-//){
        $opt_windows_drive = 1 if $argv eq 'windows-drive';
        next;
    }
    while ($argv =~ s/^(.)//){
        my $ch = $1;
        $opt_windows_drive = 1 if $ch eq 'w';
        $opt_testonly = 1 if $ch eq 't';
        $opt_verbose = 1 if $ch eq 'v';
    }
}

if (@ARGV == 2){
    &main(@ARGV);
}else{
    print "usage: $0 pattern index_directory\n";
    exit;
}

sub main{
    my $pattern = shift;
    my $index_dir = shift;

    my $nmzi = new nmzidx($index_dir, 'r');
    my $nmzo = new nmzidx($index_dir, 'w') unless $opt_testonly;

    my $nmzwi = $nmzi->open_word;
    my $nmzwo = $nmzo->open_word unless $opt_testonly;
    my ($word, %list);

    my $evalstr = "\$ret = ($pattern);\n";

    while (defined $nmzwi->read(\$word, \%list)){
        local $_ = $word;
        my $ret;
        eval($evalstr);

        if ($opt_testonly || $opt_verbose){
            if ($ret){
                print "REMAIN: $word\n";
            }else{
                print "DELETE: $word\n";
            }
        }
        if ($ret && !$opt_testonly){
            $nmzwo->write($word, \%list);
        }
    }
    $nmzwi->close;
    unless ($opt_testonly){
        $nmzwo->close;
        $nmzo->write_status($nmzi);
        $nmzo->replace_db(0);
    }
}
